TransformerFactoryImpl
Date: 2016-07-03

com.icl.saxon

## Class TransformerFactoryImpl

- java.lang.Object
- - javax.xml.transform.TransformerFactory
  - - javax.xml.transform.sax.SAXTransformerFactory
    - - com.icl.saxon.TransformerFactoryImpl

-     public class TransformerFactoryImpl
      extends javax.xml.transform.sax.SAXTransformerFactory

  A TransformerFactoryImpl instance can be used to create Transformer and Template objects.

  The system property that determines which Factory implementation to create is named "javax.xml.transform.TransformerFactory". This property names a concrete subclass of the TransformerFactory abstract class. If the property is not defined, a platform default is be used.

  This implementation class implements the abstract methods on both the javax.xml.transform.TransformerFactory and javax.xml.transform.sax.SAXTransformerFactory classes.

- - ### Field Summary

    - ### Fields inherited from class javax.xml.transform.sax.SAXTransformerFactory

      `FEATURE, FEATURE_XMLFILTER`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TransformerFactoryImpl()` Default constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `javax.xml.transform.Source` | `compositeStylesheet(javax.xml.transform.sax.SAXSource[] sources)` Process a series of stylesheet inputs, treating them in import or cascade order.
    `javax.xml.transform.Source` | `getAssociatedStylesheet(javax.xml.transform.Source source, java.lang.String media, java.lang.String title, java.lang.String charset)` Get the stylesheet specification(s) associated via the xml-stylesheet processing instruction (see http://www.w3.org/TR/xml-stylesheet/) with the document document specified in the source parameter, and that match the given criteria.
    `java.lang.Object` | `getAttribute(java.lang.String name)` Allows the user to retrieve specific attributes on the underlying implementation.
    `javax.xml.transform.ErrorListener` | `getErrorListener()` Get the error event handler for the TransformerFactory.
    `boolean` | `getFeature(java.lang.String name)` Look up the value of a feature.
    `javax.xml.transform.sax.SAXSource` | `getSAXSource(javax.xml.transform.Source source, boolean isStyleSheet)` Convert a supplied Source to a SAXSource
    `org.xml.sax.XMLReader` | `getSourceParser()` Get the parser for source documents
    `org.xml.sax.XMLReader` | `getStyleParser()` Get the parser for stylesheet documents
    `javax.xml.transform.URIResolver` | `getURIResolver()` Get the object that is used by default during the transformation to resolve URIs used in document(), xsl:import, or xsl:include.
    `static org.xml.sax.XMLReader` | `makeParser(java.lang.String className)` Create a new SAX XMLReader object using the class name provided. The named class must exist and must implement the org.xml.sax.XMLReader or Parser interface. This method returns an instance of the parser named.
    `javax.xml.transform.Templates` | `newTemplates(javax.xml.transform.Source source)` Process the Source into a Templates object, which is a a compiled representation of the source.
    `javax.xml.transform.sax.TemplatesHandler` | `newTemplatesHandler()` Get a TemplatesHandler object that can process SAX ContentHandler events into a Templates object.
    `javax.xml.transform.Transformer` | `newTransformer()` Create a new Transformer object that performs a copy of the source to the result.
    `javax.xml.transform.Transformer` | `newTransformer(javax.xml.transform.Source source)` Process the Source into a Transformer object.
    `javax.xml.transform.sax.TransformerHandler` | `newTransformerHandler()` Get a TransformerHandler object that can process SAX ContentHandler events into a Result.
    `javax.xml.transform.sax.TransformerHandler` | `newTransformerHandler(javax.xml.transform.Source src)` Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the transformation instructions specified by the argument.
    `javax.xml.transform.sax.TransformerHandler` | `newTransformerHandler(javax.xml.transform.Templates templates)` Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the Templates argument.
    `org.xml.sax.XMLFilter` | `newXMLFilter(javax.xml.transform.Source src)` Create an XMLFilter that uses the given Source as the transformation instructions.
    `org.xml.sax.XMLFilter` | `newXMLFilter(javax.xml.transform.Templates templates)` Create an XMLFilter, based on the Templates argument..
    `void` | `setAttribute(java.lang.String name, java.lang.Object value)` Allows the user to set specific attributes on the underlying implementation.
    `void` | `setErrorListener(javax.xml.transform.ErrorListener listener)` Set the error event listener for the TransformerFactory, which is used for the processing of transformation instructions, and not for the transformation itself.
    `void` | `setFeature(java.lang.String name, boolean value)` Set a feature for this `TransformerFactory` and `Transformer`s or `Template`s created by this factory.
    `void` | `setURIResolver(javax.xml.transform.URIResolver resolver)` Set an object that is used by default during the transformation to resolve URIs used in xsl:import, or xsl:include.

    - ### Methods inherited from class javax.xml.transform.TransformerFactory

      `newInstance, newInstance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TransformerFactoryImpl

          public TransformerFactoryImpl()

      Default constructor.

  - ### Method Detail

    - #### newTransformer

          public javax.xml.transform.Transformer newTransformer(javax.xml.transform.Source source)
                                                         throws javax.xml.transform.TransformerConfigurationException

      Process the Source into a Transformer object. Care must be given not to use this object in multiple threads running concurrently. Different TransformerFactories can be used concurrently by different threads.
      Specified by:
        `newTransformer` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `source` - An object that holds a URI, input stream, etc.
      Returns:
        A Transformer object that may be used to perform a transformation in a single thread, never null.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - May throw this during the parse when it is constructing the Templates object and fails.

    - #### newTransformer

          public javax.xml.transform.Transformer newTransformer()
                                                         throws javax.xml.transform.TransformerConfigurationException

      Create a new Transformer object that performs a copy of the source to the result.
      Specified by:
        `newTransformer` in class `javax.xml.transform.TransformerFactory`
      Returns:
        A Transformer object that may be used to perform a transformation in a single thread, never null.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - May throw this during the parse when it is constructing the Templates object and fails.

    - #### newTemplates

          public javax.xml.transform.Templates newTemplates(javax.xml.transform.Source source)
                                                     throws javax.xml.transform.TransformerConfigurationException

      Process the Source into a Templates object, which is a a compiled representation of the source. This Templates object may then be used concurrently across multiple threads. Creating a Templates object allows the TransformerFactory to do detailed performance optimization of transformation instructions, without penalizing runtime transformation.
      Specified by:
        `newTemplates` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `source` - An object that holds a URL, input stream, etc.
      Returns:
        A Templates object capable of being used for transformation purposes, never null.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - May throw this during the parse when it is constructing the Templates object and fails.

    - #### getSAXSource

          public javax.xml.transform.sax.SAXSource getSAXSource(javax.xml.transform.Source source,
                                                       boolean isStyleSheet)

      Convert a supplied Source to a SAXSource
      Parameters:
        `source` - The supplied input source
        `isStyleSheet` - true if the source is a stylesheet
      Returns:
        a SAXSource

    - #### getAssociatedStylesheet

          public javax.xml.transform.Source getAssociatedStylesheet(javax.xml.transform.Source source,
                                                           java.lang.String media,
                                                           java.lang.String title,
                                                           java.lang.String charset)
                                                             throws javax.xml.transform.TransformerConfigurationException

      Get the stylesheet specification(s) associated via the xml-stylesheet processing instruction (see http://www.w3.org/TR/xml-stylesheet/) with the document document specified in the source parameter, and that match the given criteria. Note that it is possible to return several stylesheets, in which case they are applied as if they were a list of imports or cascades.
      Specified by:
        `getAssociatedStylesheet` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `source` - The XML source document.
        `media` - The media attribute to be matched. May be null, in which case the prefered templates will be used (i.e. alternate = no).
        `title` - The value of the title attribute to match. May be null.
        `charset` - The value of the charset attribute to match. May be null.
      Returns:
        A Source object suitable for passing to the TransformerFactory.
      Throws:
        `javax.xml.transform.TransformerConfigurationException`

    - #### compositeStylesheet

          public javax.xml.transform.Source compositeStylesheet(javax.xml.transform.sax.SAXSource[] sources)
                                                         throws javax.xml.transform.TransformerConfigurationException

      Process a series of stylesheet inputs, treating them in import or cascade order. This is mainly for support of the getAssociatedStylesheets method, but may be useful for other purposes.
      Parameters:
        `sources` - An array of SAX InputSource objects.
      Returns:
        A Source object representing a composite stylesheet.
      Throws:
        `javax.xml.transform.TransformerConfigurationException`

    - #### setURIResolver

          public void setURIResolver(javax.xml.transform.URIResolver resolver)

      Set an object that is used by default during the transformation to resolve URIs used in xsl:import, or xsl:include.
      Specified by:
        `setURIResolver` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `resolver` - An object that implements the URIResolver interface, or null.

    - #### getURIResolver

          public javax.xml.transform.URIResolver getURIResolver()

      Get the object that is used by default during the transformation to resolve URIs used in document(), xsl:import, or xsl:include.
      Specified by:
        `getURIResolver` in class `javax.xml.transform.TransformerFactory`
      Returns:
        The URIResolver that was set with setURIResolver.

    - #### setFeature

          public void setFeature(java.lang.String name,
                        boolean value)
                          throws javax.xml.transform.TransformerConfigurationException

      Set a feature for this `TransformerFactory` and `Transformer`s or `Template`s created by this factory.

      Feature names are fully qualified `URI`s. Implementations may define their own features. An `TransformerConfigurationException` is thrown if this `TransformerFactory` or the `Transformer`s or `Template`s it creates cannot support the feature. It is possible for an `TransformerFactory` to expose a feature value but be unable to change its state.

      All implementations are required to support the `XMLConstants.FEATURE_SECURE_PROCESSING` feature. When the feature is:

      - `true`: the implementation will limit XML processing to conform to implementation limits and behave in a secure fashion as defined by the implementation. Examples include resolving user defined style sheets and functions. If XML processing is limited for security reasons, it will be reported via a call to the registered `ErrorListener.fatalError(javax.xml.transform.TransformerException exception)`. See `setErrorListener(javax.xml.transform.ErrorListener listener)`.
      - `false`: the implementation will processing XML according to the XML specifications without regard to possible implementation limits.

      The Saxon implementation does not support the secure processing feature.

      Specified by:
        `setFeature` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `name` - Feature name.
        `value` - Is feature state `true` or `false`.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - if this `TransformerFactory` or the `Transformer`s or `Template`s it creates cannot support this feature.
        `java.lang.NullPointerException` - If the `name` parameter is null.

    - #### getFeature

          public boolean getFeature(java.lang.String name)

      Look up the value of a feature.

      The feature name is any absolute URI.

      Specified by:
        `getFeature` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `name` - The feature name, which is an absolute URI.
      Returns:
        The current state of the feature (true or false).

    - #### setAttribute

          public void setAttribute(java.lang.String name,
                          java.lang.Object value)
                            throws java.lang.IllegalArgumentException

      Allows the user to set specific attributes on the underlying implementation. An attribute in this context is defined to be an option that the implementation provides.
      Specified by:
        `setAttribute` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `name` - The name of the attribute. This must be one of the constants defined in class FeatureKeys.
        `value` - The value of the attribute.
      Throws:
        `java.lang.IllegalArgumentException` - thrown if Saxon doesn't recognize the attribute.

    - #### getAttribute

          public java.lang.Object getAttribute(java.lang.String name)
                                        throws java.lang.IllegalArgumentException

      Allows the user to retrieve specific attributes on the underlying implementation.
      Specified by:
        `getAttribute` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `name` - The name of the attribute.
      Returns:
        value The value of the attribute.
      Throws:
        `java.lang.IllegalArgumentException` - thrown if the underlying implementation doesn't recognize the attribute.

    - #### setErrorListener

          public void setErrorListener(javax.xml.transform.ErrorListener listener)
                                throws java.lang.IllegalArgumentException

      Set the error event listener for the TransformerFactory, which is used for the processing of transformation instructions, and not for the transformation itself.
      Specified by:
        `setErrorListener` in class `javax.xml.transform.TransformerFactory`
      Parameters:
        `listener` - The new error listener.
      Throws:
        `java.lang.IllegalArgumentException` - if listener is null.

    - #### getErrorListener

          public javax.xml.transform.ErrorListener getErrorListener()

      Get the error event handler for the TransformerFactory.
      Specified by:
        `getErrorListener` in class `javax.xml.transform.TransformerFactory`
      Returns:
        The current error handler, which should never be null.

    - #### getSourceParser

          public org.xml.sax.XMLReader getSourceParser()
                                                throws javax.xml.transform.TransformerFactoryConfigurationError

      Get the parser for source documents
      Throws:
        `javax.xml.transform.TransformerFactoryConfigurationError`

    - #### getStyleParser

          public org.xml.sax.XMLReader getStyleParser()
                                               throws javax.xml.transform.TransformerFactoryConfigurationError

      Get the parser for stylesheet documents
      Throws:
        `javax.xml.transform.TransformerFactoryConfigurationError`

    - #### makeParser

          public static org.xml.sax.XMLReader makeParser(java.lang.String className)
                                                  throws javax.xml.transform.TransformerFactoryConfigurationError

      Create a new SAX XMLReader object using the class name provided.
      The named class must exist and must implement the org.xml.sax.XMLReader or Parser interface.
      This method returns an instance of the parser named.
      Parameters:
        `className` - A string containing the name of the SAX parser class, for example "com.microstar.sax.LarkDriver"
      Returns:
        an instance of the Parser class named, or null if it is not loadable or is not a Parser.
      Throws:
        `javax.xml.transform.TransformerFactoryConfigurationError`

    - #### newTransformerHandler

          public javax.xml.transform.sax.TransformerHandler newTransformerHandler(javax.xml.transform.Source src)
                                                                           throws javax.xml.transform.TransformerConfigurationException

      Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the transformation instructions specified by the argument.
      Specified by:
        `newTransformerHandler` in class `javax.xml.transform.sax.SAXTransformerFactory`
      Parameters:
        `src` - The Source of the transformation instructions.
      Returns:
        TransformerHandler ready to transform SAX events.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - If for some reason the TransformerHandler can not be created.

    - #### newTransformerHandler

          public javax.xml.transform.sax.TransformerHandler newTransformerHandler(javax.xml.transform.Templates templates)
                                                                           throws javax.xml.transform.TransformerConfigurationException

      Get a TransformerHandler object that can process SAX ContentHandler events into a Result, based on the Templates argument.
      Specified by:
        `newTransformerHandler` in class `javax.xml.transform.sax.SAXTransformerFactory`
      Parameters:
        `templates` - The compiled transformation instructions.
      Returns:
        TransformerHandler ready to transform SAX events.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - If for some reason the TransformerHandler can not be created.

    - #### newTransformerHandler

          public javax.xml.transform.sax.TransformerHandler newTransformerHandler()
                                                                           throws javax.xml.transform.TransformerConfigurationException

      Get a TransformerHandler object that can process SAX ContentHandler events into a Result. The transformation is defined as an identity (or copy) transformation, for example to copy a series of SAX parse events into a DOM tree.
      Specified by:
        `newTransformerHandler` in class `javax.xml.transform.sax.SAXTransformerFactory`
      Returns:
        A non-null reference to a TransformerHandler, that may be used as a ContentHandler for SAX parse events.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - If for some reason the TransformerHandler cannot be created.

    - #### newTemplatesHandler

          public javax.xml.transform.sax.TemplatesHandler newTemplatesHandler()
                                                                       throws javax.xml.transform.TransformerConfigurationException

      Get a TemplatesHandler object that can process SAX ContentHandler events into a Templates object.
      Specified by:
        `newTemplatesHandler` in class `javax.xml.transform.sax.SAXTransformerFactory`
      Returns:
        A non-null reference to a TransformerHandler, that may be used as a ContentHandler for SAX parse events.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - If for some reason the TemplatesHandler cannot be created.

    - #### newXMLFilter

          public org.xml.sax.XMLFilter newXMLFilter(javax.xml.transform.Source src)
                                             throws javax.xml.transform.TransformerConfigurationException

      Create an XMLFilter that uses the given Source as the transformation instructions.
      Specified by:
        `newXMLFilter` in class `javax.xml.transform.sax.SAXTransformerFactory`
      Parameters:
        `src` - The Source of the transformation instructions.
      Returns:
        An XMLFilter object, or null if this feature is not supported.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - If for some reason the XMLFilter cannot be created.

    - #### newXMLFilter

          public org.xml.sax.XMLFilter newXMLFilter(javax.xml.transform.Templates templates)
                                             throws javax.xml.transform.TransformerConfigurationException

      Create an XMLFilter, based on the Templates argument..
      Specified by:
        `newXMLFilter` in class `javax.xml.transform.sax.SAXTransformerFactory`
      Parameters:
        `templates` - The compiled transformation instructions.
      Returns:
        An XMLFilter object, or null if this feature is not supported.
      Throws:
        `javax.xml.transform.TransformerConfigurationException` - If for some reason the XMLFilter cannot be created.